#define _BAN_C_ 1
/* ban.c - banlist capability for Lorien
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#ifdef POSIX
#include <sys/select.h>
#endif
#include <sys/time.h>
#include <sys/resource.h>
#include "lorien.h"

ban_t *bantail;
ban_t *banlist = null(ban_t);

void
ban_read_blockfile()
{
    FILE *banfile;
    char *tmp;
    char  s[BUFSIZE];

    banfile = fopen(BLOCKFILE,"r");
    if (banfile) {
	while (!feof(banfile)) {
	    fgets(s,BUFSIZE - 1,banfile);
	    if (!feof(banfile)) {
		if (tmp = (char *) strstr(s,"\r"))
		    *tmp = (char) 0;
		if (tmp = (char *) strstr(s,"\n"))
		    *tmp = (char) 0;
		ban_add(s);
	    }
	}
	fclose(banfile);
    }
}

ban_t *
ban_findsite(s)
    char *s;
{
    ban_t *tmp;

    tmp = banlist;

    while (tmp) {
	if (strcontains(s, tmp->site, SUB) && !tmp->free)
	    return tmp;
	tmp = tmp->next;
    };
    return null(ban_t);
}

ban_t *
ban_findfree()
{
    ban_t *tmp = banlist;

    while (tmp) {
	bantail = tmp;
	if (tmp->free)
	    return tmp;
	tmp = tmp->next;
    };
    return null(ban_t);
}

ban_t *
ban_alloc()
{
    ban_t *tmp;

    tmp = new(ban_t);
    tmp->next = null(ban_t);
    tmp->free = 0;

    return tmp;
}

ban_t *
ban_init()
{
    banlist = ban_alloc();
    return banlist;
}

int
ban_add(s)
    char *s;
{
    ban_t *curr;

    if (curr = ban_findsite(s))
	return 1;

    if (!banlist) 
	curr = ban_init();
    else if (curr = ban_findfree())
	curr->free = 0;
    else {
	curr = ban_alloc();
	bantail->next = curr;
    }

    strcpy(curr->site,s);
   
    return 1;
}

char *
ban_remove(s)
    char *s;
{
    ban_t *tmp;
    tmp = ban_findsite(s);

    if (tmp) {
	tmp->free = 1;
	return tmp->site;
    }
    return (char *) 0;
}

int
ban_list(who)
    struct splayer *who;
{
    char sendbuf[OBUFSIZE];
    ban_t *tmp = banlist;

    sprintf(sendbuf,">> The following sites are banned:\r\n");
    sendtoplayer(who,sendbuf);
    while (tmp) {
	if (!tmp->free) {
	    sprintf(sendbuf,">> %s\r\n",tmp->site);
	    sendtoplayer(who,sendbuf);
	}
	tmp = tmp->next;
    }
    return 1;
}
